//this is the giant head the kills the player

class Finisher {
  float x, y;  //location
  boolean active;  //keeps track of if this thing is currently in play
  float yOffset=-30;  //needs to be raised a bit form ship's y pos
  
  //showing the image
  PImage pic;

  float killHeight=60;  //what the raisingY needs to be to kill the ship
  boolean killShip;  //becomes true when the head is out of the water enough to kill the ship

  //raising out of the water
  float raisingDir=0;  //-1 means raising up & 1 means going down
  float raisingSpeed=10;  //how fast it rises or sinks
  float raisingY=0;      //how far out of the water the boss is
  float raisingPadding=50;  //how much of the image of to leave in the water
  float waveHeight=10;    //how high the water should come up
  //image mask
  int maskValues[];
  boolean maskTrans[];      //the pixels that need to remain transparent
  int transThreshold=100;   //transparency bellow this will be ignored

  //timing
  int nextRaiseTime=0;
  int raiseTimes[];
  int lowerTimes[];
  int nextLowerTime=0;

  Finisher() { 
    killShip=false;
    pic=loadImage("data/pics/whirlpoolMonsterFinisher.png");
    maskValues=new int[pic.width*pic.height];

    //go thorugh the image and figure out which pixels must remain transparent (this is because masking in Processing is dumb as hell)
    pic.loadPixels();  //get the pixels from the image
    maskTrans=new boolean[pic.width*pic.height];
    for (int i=0; i<maskTrans.length; i++) {
      maskTrans[i]=true;
      color col=pic.pixels[i];
      int a= (col >> 24) & 0xFF;  //bit shift for the alpha value
      if (a>transThreshold) {
        maskTrans[i]=false;
      }
    }

    setTimes();
  }

  void update(int time) {

    checkTiming(time);

   //keep the finisher on the player
   x=ship.x;
   y=ship.y+yOffset;


    //if this is at all visible, it is active
    active=raisingY>0;

    //if it is raising or lowering, adjust the mask
    if (raisingDir!=0) {
      raisingY+= raisingSpeed*raisingDir;

      //check if we reached the top or bottom of the image
      if (raisingY>=pic.height-raisingPadding || raisingY<=0)  raisingDir=0;
    }

    //adjust the mask for the image
    for (int c=0; c<pic.width; c++) {
      //figure out where in this column the water is in order to mask the things beneath it
      //add some noise to the value to simulate waves
      int yCutOff=(int) (raisingY-noise(c*0.1, millis()*0.001)*waveHeight );


      for (int r=0; r<pic.height; r++) {
        int pos=r*pic.width+c;  //where in the array it is
        //if this is in the transparent part of the image, keep it that way
        if (maskTrans[pos])
          maskValues[pos]=0;
        else {
          //otherwise, adjust it depending on the raisingY
          if (r<=yCutOff)  maskValues[pos]=255;
          else             maskValues[pos]=0;
        }
      }
    }
    
    
    //is it time to kill the ship?
    if (raisingY>killHeight)  killShip=true;

  }

  void checkTiming(int time) {
    //time to raise?
    if (nextRaiseTime<raiseTimes.length) {
      if (time>raiseTimes[nextRaiseTime]) {
        raise(1);
        nextRaiseTime++;
      }
    }
     //time to lower?
    if (nextLowerTime<lowerTimes.length) {
      if (time>lowerTimes[nextLowerTime]) {
        raise(-1);
        nextLowerTime++;
      }
    }
  }

  void draw() {

    imageMode(CENTER); 
    pushMatrix();
    translate(x, y+pic.height-raisingY);
    tint(255, 255, 255);
    pic.mask(maskValues);
    image(pic, 0, 0);
    popMatrix();
  }

  //causes the monster to sink or rise
  void raise(int dir) {
    raisingDir=dir;
    //make sure it is in place
    raisingY=constrain(raisingY, 0, pic.height-raisingPadding);
  }

   //hard code the times that this thing needs to charge
  void setTimes() {
    raiseTimes=new int[1];
    raiseTimes[0]=167820;
    
    lowerTimes=new int[1];
    lowerTimes[0]=169050;
    
  }
  
  //advances all timers to this point in the song
  void skipTo(int time) {
    for (int i=0; i<raiseTimes.length; i++)
      if (time > raiseTimes[i])  nextRaiseTime=i;
    for (int i=0; i<lowerTimes.length; i++)
      if (time > lowerTimes[i])  nextLowerTime=i;
  }
  
}

