//whirl pools swirl around one of the monsters
class WhirlPool {
  float x, y;  //location
  float hitSize;

  float retreatSpeed=6;  //how quickly it moves back to the monster
  float minDist=150;     //how close it can get to the monster
  float distFromCenter=minDist;  //reset by the monster

  //rotating around the center
  float curAngle;
  float rotSpeed=-0.01;
  
  //spinning the pic
  float spinAngle=0;
  float spinSpeed=0.1;
  
  //the pic grows and shrinks when the monster is rising or lowering
  float imageScale=1;

  PImage pic;

  float crunch=0.5;  //how much to shrink the image verticlly 
  
  WhirlPool(float startAngle){
     pic=loadImage("data/pics/whirlpool.png");

    //hit range will be half the size of the image
    hitSize=pic.width/4;
    
    curAngle=startAngle;
  }

  void update(float centerX, float centerY) {
    //keep rotating around the monster
    curAngle+=rotSpeed;
    //move the whirlpool around the monster's center
    x=centerX+cos(curAngle)*distFromCenter;
    y=centerY+sin(curAngle)*distFromCenter;
    
    //keep the thing spinning
    spinAngle+=spinSpeed;
    
    //have the pool retreat towards the min dist
    if (distFromCenter>minDist)  distFromCenter-=retreatSpeed;
  }

  void draw() {
    pushMatrix();
    translate(x,y);
    scale(1,crunch);
    rotate(spinAngle);
    scale(imageScale,imageScale);
    image(pic,0,0);
    popMatrix();
    
    //draw the hit box
//    noFill();
//    stroke(255, 0, 0);
//    ellipse(x,y,hitSize,hitSize);
  }

  void setDist(float newDist) {
    distFromCenter+=newDist;
    distFromCenter=max(minDist,distFromCenter);
  }
  
  //checks to see if the whirlpool is touching the ship's hit box
  //takes the ship's hit box in the form of the upper left and lower right corners
  boolean checkHit(float x1, float x2, float y1, float y2){
    return (x+hitSize>x1 && x-hitSize<x2 && y+hitSize>y1 && y-hitSize<y2);
  }
}

